// CryptExplore.cpp : Defines the entry point for the console application.
//http://www.microsoft.com/technet/security/cryptech.asp

/*
 * Copyright (c) 2001
 *	Dmitry Selin aka Demo_S.  All rights reserved.
 *  s_daemon@yahoo.com
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by Demo_S'' The name may not
 * be used to endorse or promote products derived from this software without specific prior
 * written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/



#include "stdafx.h"
//#include "stdio.h"
#include <stdlib.h>

//#include <winbase.h>
//#include "Wincrypt.h"


	HCRYPTPROV hCryptProv;        // Handle for the 
			                      // cryptographic provider context.
	HCRYPTKEY hKey,hExchangeKey;               // key to crypt data and Public/private key handle.

	LPCTSTR UserName=NULL;//   -,    NULL,      

	FILE *hSource; //  -   
	FILE *hDestination; 

void HandleError(char *s,DWORD e)
{
    printf("An error occurred in running the program.\n");
    printf("%s\n",s);
    printf("Error number %x\n.",e);
    printf("Program terminating.\n");
    exit(1);
}
	
void CheckContainer(const char* UserName)//,    ,  ,    
{
	if(CryptAcquireContext(
	    &hCryptProv, 
		UserName, 
		MS_DEF_PROV, 
		PROV_RSA_FULL, 
		CRYPT_NEWKEYSET)) 
	{
		printf("A new key container has been created.\n");
	}
	else
	{
		HandleError("Could not create a new key container.\n",GetLastError());
	}
	
}
void CheckKeySet(HCRYPTPROV hCryptProv)//   -    ,   
{	//,     
	//--------------------------------------------------------------------
	// A cryptographic context and a key container is available. Get the
	// name of the key container. 
	char szUserName[100];
	DWORD dwUserNameLen=100;
	if(CryptGetProvParam(
		hCryptProv,               // Handle to the CSP
		PP_CONTAINER,             // Get the key container name 
		(BYTE *)szUserName,       // Pointer to the key container name
		&dwUserNameLen,           // Length of name, preset to 100
		0)) 
	{
		printf("A crypto context has been acquired and \n");
		printf("The name on the key container is %s\n\n",szUserName);
	}
	else
	{
		// Error getting key container name
	    HandleError("A context was acquired or created, but	an error occurred getting the key container name.\n",GetLastError());
	} 

	//,       ,  ,   
	//--------------------------------------------------------------------
	// A context with a key container is available,
	// Attempt to get the handle to signature key. 

	if(CryptGetUserKey(
		hCryptProv,                     // Handle to the CSP
		AT_SIGNATURE,                   // Key specification
		&hKey))                         // Handle to the key
	{
		printf("A signature key is available.\n");
	}
	else
	{
	    printf("No signature key is available.\n");
	    if(GetLastError() == NTE_NO_KEY) //       ,   ,   
	    {
	    //----------------------------------------------------------------
	    // The error was that there is a container but no key.
	
	    // Create a signature key pair. 
			printf("The signature key does not exist.\n");
			printf("Create a signature key pair.\n"); 
			if(CryptGenKey(
				hCryptProv,
				AT_SIGNATURE,// 
				CRYPT_EXPORTABLE,
				&hKey)) //,    ,     
			{
				printf("Created a signature key pair.\n");
			}
			else
			{
				HandleError("Error occurred creating a signature key.\n",GetLastError()); 
			}
		}
		else
		{
			HandleError("An error other than NTE_NO_KEY getting signature key.\n",GetLastError());
		}
	} // End of if


	printf("A signature key pair existed, or one was created.\n\n");
	CryptDestroyKey(hKey); //    


	// ,     -   ,  /
	// Next, check the exchange key. 
	if(CryptGetUserKey(
		hCryptProv,
		AT_KEYEXCHANGE,
		&hKey)) 
	{
		printf("An exchange key exists. \n");
	}
	else
	{
		printf("No exchange key is available.\n");
		// Check to see if one needs to be created.
		if(GetLastError()==NTE_NO_KEY) //  ,    .
		{ 
		// Create an key exchange key pair.
			printf("The exchange key does not exist.\n");
			printf("Attempting to create an exchange key pair.\n");
			if(CryptGenKey(
				hCryptProv,
				AT_KEYEXCHANGE,// (  ,   ,   exchange)
				CRYPT_EXPORTABLE,
				&hKey)) 
			{
				printf("Exchange key pair created.\n");
			}
			else
			{
				HandleError("Error occurred attempting to create an exchange key.\n",GetLastError());
			}
		}
		else
		{
			HandleError("An error other than NTE_NO_KEY occurred.\n",GetLastError());
		}
	}//end if ,     
	printf("An exchange key pair existed, or one was created.\n\n");
	CryptDestroyKey(hKey); //   


}//End CheckKeySet

void Usage()
{
	printf("Simple program that ciphers files, \n");
	printf("using keys, that are installed for current user\n");
	printf("if such keys doesn't exist, they will be created\n");

	printf("Copyleft (L) Demo_S 2001\n s_daemon@yahoo.com\n");
	printf("Usage:\n");

	printf("CryptExplore e source dest keyfile\n");
	printf("To encode file source with someones public key that is contained in keyfile\n");
	printf("If current user hasn't  publick&private key, they'll be created\n");
	
	printf("CryptExplore d source, dest\n");
	printf("To decode file source to dest with your own private key\n");
	
	printf("CryptExplore x dest\n");
	printf("To export your own oublic key to file dest\n");
	
	printf("CryptExplore r\n");
	printf("To (erase)delete keys container, associated with user\n");
	printf("Note: file dest will be overwritten if exist\n");
	exit(0);





}
int main(int argc, char* argv[])
{
	//UserName:=new char[100];
	//GetUserName(UserName,100);
	// 
	if ( (argc==2)&&(lstrcmpi(argv[1],"r")==0) )
	{//    UserName
		if(CryptAcquireContext(
			&hCryptProv,               // Handle to the CSP
			UserName,                  // Container name 
			MS_DEF_PROV,               // Provider name (default)="Microsoft Base Cryptographic Provider v1.0"
			PROV_RSA_FULL,             // Provider type
			CRYPT_DELETEKEYSET))                        // Flag values
		{
			printf("sucesfully deleted container %s",UserName);
			return 0;
		}
		else  
		{ 
			HandleError("failed to delete container",GetLastError());
		}

	}
	else
	{
	
	
		//   , ,     ,  
		if(CryptAcquireContext(	//    ,       
			&hCryptProv,               // Handle to the CSP
			UserName,                  // Container name 
			MS_DEF_PROV,               // Provider name (default)="Microsoft Base Cryptographic Provider v1.0"
			PROV_RSA_FULL,             // Provider type
			0))                        // Flag values
		{
	
			printf("A crypto context with the %s key container \n", UserName);
			printf("has been acquired.\n\n");
		}
		else
		{
			if(GetLastError()==NTE_BAD_KEYSET)//  (UserName)  ,       <private/public>keys
			{
				CheckContainer(UserName);
			}
			else {HandleError("Error while creating new context",GetLastError());}
		}



		CheckKeySet(hCryptProv);//  

		//  
			BYTE* lpData=NULL;
			BYTE* lpTempData=NULL;
			DWORD dwDataLen=0;
			bool b;//  -     case .    -  .
			DWORD dwBufLen=1024;	
			int a;
		switch (argc)
		{
		case 3:
			// .   .   ,  stricmp(argv[1],"x")==0
			CryptGetUserKey(hCryptProv,AT_KEYEXCHANGE,&hKey);//     /
			b=(bool)CryptExportKey(hKey,0,PUBLICKEYBLOB,0,NULL,&dwDataLen);//  .  1  
			lpData=(BYTE*)malloc(dwDataLen);
			b&=(bool)lpData;
			b&=(bool)CryptExportKey(hKey,NULL,PUBLICKEYBLOB,0,lpData,&dwDataLen);// 1  /   .
			CryptDestroyKey(hKey);//   
			if(!b)
			{
				
				free(lpData);
				CryptReleaseContext(hCryptProv,0);
				HandleError("Error while exporting key\n",GetLastError());
			}
			
			//     .
			hDestination=fopen(argv[2],"wb");
			fwrite(&dwDataLen,sizeof(DWORD),1,hDestination);//  , keyblob'a
			if(fwrite(lpData,sizeof(BYTE),dwDataLen,hDestination)!=dwDataLen)
			{
				fclose(hDestination);
				free(lpData);
				CryptReleaseContext(hCryptProv,0);
				HandleError("Error while writing to file\n",GetLastError());
			}
			fclose(hDestination);
			free(lpData);
			break;
		case 4:// 
			
					
			/*
			if(!CryptGetUserKey(hCryptProv,AT_KEYEXCHANGE,&hExchangeKey))
			{
				CryptReleaseContext(hCryptProv,0);
				HandleError("Failed to get user private key",GetLastError());
			}
			
			*/
			hSource=fopen(argv[2],"rb");

			fread(&dwDataLen,sizeof(DWORD),1,hSource);//      
			lpData=(BYTE*)malloc(dwDataLen);
			b=(bool)lpData;//
			b&=(fread(lpData,sizeof(BYTE),dwDataLen,hSource)==dwDataLen);//    dwDataLen (      )
			if(!b)
			{
				fclose(hSource);
				free(lpData);
				CryptDestroyKey(hExchangeKey);
				CryptReleaseContext(hCryptProv,0);
				HandleError("Error while reading leviy kluch",GetLastError());
			}


			if(!CryptImportKey(hCryptProv,lpData,dwDataLen,0/*hExchangeKey*/,0,&hKey))/*  .    hKey. 
														      .   , 
														       () ,
														   ,      hExchangeKey.*/
			{
				fclose(hSource);
				free(lpData);
				CryptDestroyKey(hExchangeKey);
				CryptReleaseContext(hCryptProv,0);
				HandleError("Error while public importing key",GetLastError());
			}
			
			free(lpData);
	//		CryptDestroyKey(hExchangeKey);//     . 
			
			hDestination=fopen(argv[3],"wb");

			//   .
			/* MSDN   :     ,    CryptDecrypt
			    ,      .   
			  .    dwBufLen=1000-1000*ENCRYPT_BLOCK_SIZE. 
			  define ENCRYPT_BLOCK_SIZE 8.    ,     CALG_RC2 - 
			 .    CALG_RC4 - . (   ,   ,   
			,      ,        , 
			 dwBufLen .        -  CryptGetKeyParam*/
			dwDataLen=sizeof(DWORD);
			CryptGetKeyParam(hKey,KP_BLOCKLEN,(BYTE*)&dwBufLen,&dwDataLen,0);
					/*    b dwBufLen   CryptGetKeyParam  0..*/
			if(!dwBufLen/*  */) dwBufLen=1;
			dwBufLen=1024-1024%dwBufLen;// dwBufLen   ,   .
			lpData=(BYTE*)malloc(dwBufLen);
			//if(!lpData) ,   !
			do
			{
				
				dwDataLen=fread(lpData,sizeof(BYTE),dwBufLen,hSource);
				if(ferror(hSource))
				{
					free(lpData);
					fclose(hSource);
					fclose(hDestination);
					CryptDestroyKey(hKey);
					CryptReleaseContext(hCryptProv,0);
				    HandleError("Error reading ciphertext!",GetLastError());
				}
				// Decrypt data. 
				if(!CryptDecrypt(
					hKey, 
					0, 
					feof(hSource), 
					0, 
					lpData, 
					&dwDataLen))
					{
						free(lpData);
						fclose(hSource);
						fclose(hDestination);
						CryptDestroyKey(hKey);
						CryptReleaseContext(hCryptProv,0);
						HandleError("Error during CryptDecrypt!",GetLastError()); 
					}
					//--------------------------------------------------------------------
					// Write data to destination file. 

					fwrite(lpData,sizeof(BYTE),dwDataLen,hDestination); 
					if(ferror(hDestination))
					{
						free(lpData);
						fclose(hSource);
						fclose(hDestination);
						CryptDestroyKey(hKey);
						CryptReleaseContext(hCryptProv,0);
   						HandleError("Error writing plaintext!",GetLastError()); 
					}


			}while(!feof(hSource));
			fclose(hSource);
			fclose(hDestination);
			free(lpData);
			CryptDestroyKey(hKey);
			CryptReleaseContext(hCryptProv,0);
			
			break;
		case 5:
			// .   KeyFile
			hSource=fopen(argv[4],"rb");
			fread(&dwDataLen,sizeof(DWORD),1,hSource);
			lpData=(BYTE*)malloc(dwDataLen);
			b=(bool)lpData;//  
			b&=(bool)fread(lpData,sizeof(BYTE),dwDataLen,hSource);// .   1   
			fclose(hSource);
			
			if(!b) 
			{
				free(lpData);
				CryptReleaseContext(hCryptProv,0);
				HandleError("Error while reading key from file",GetLastError());
			}
	//		hKey=0;
			if(!CryptImportKey(hCryptProv,lpData,dwDataLen,0,0,&hExchangeKey))//  .    hExchangeKey
			{
				free(lpData);
				CryptReleaseContext(hCryptProv,0);
				HandleError("Error while public importing key",GetLastError());
			}
			free(lpData);
			
			hSource=fopen(argv[2],"rb");

			if(!CryptGenKey(hCryptProv,CALG_RC4,CRYPT_EXPORTABLE,&hKey))//  ,      . (  "leviy kluch")
			{
				CryptDestroyKey(hExchangeKey);
				free(lpData);
				CryptReleaseContext(hCryptProv,0);
				HandleError("Error while generating leviy kluch",GetLastError());
			}

			//,    ,      .
			hDestination=fopen(argv[3],"wb");
			
			b=(bool)CryptExportKey(hKey,hExchangeKey,SIMPLEBLOB,0,NULL,&dwDataLen);//  .  1  
			lpData=(BYTE*)malloc(dwDataLen);
			b&=(bool)lpData;
			b&=(bool)CryptExportKey(hKey,hExchangeKey,SIMPLEBLOB,0,lpData,&dwDataLen);// 1  
			if(!b)
			{
				CryptDestroyKey(hKey);
				CryptDestroyKey(hExchangeKey);
				free(lpData);
				CryptReleaseContext(hCryptProv,0);
				HandleError("Error while exporting leviy key\n",GetLastError());
			}
			CryptDestroyKey(hExchangeKey);//  ()   .       ,  
			fwrite(&dwDataLen,sizeof(DWORD),1,hDestination);//  , keyblob'a
			if(fwrite(lpData,sizeof(BYTE),dwDataLen,hDestination)!=dwDataLen)//    
			{
				fclose(hDestination);
				free(lpData);
				CryptDestroyKey(hKey);
				CryptReleaseContext(hCryptProv,0);
				HandleError("Error while writing leviy kluch to file\n",GetLastError());
			}
			free(lpData);//     

			bool Eof;
			dwDataLen=dwBufLen;
			if(!CryptEncrypt(hKey,NULL,true,0,NULL,&dwDataLen,dwBufLen))/*  ,    
																	   .  , 
																	      
																	 .       
																	   ,    
																	 2048,      1024.   , 
																	     
																	    ,  
																	 .*/
			{
			//	a=GetLastError();
				CryptDestroyKey(hKey);
				CryptReleaseContext(hCryptProv,0);
				free(lpData);
				HandleError("Error while retrieving buffer size for ciphered text",GetLastError());
			}
			lpData=(BYTE*)malloc(1024);//    
			dwBufLen=dwDataLen;
			lpTempData=(BYTE*)malloc(dwBufLen);//     
			do
			{

				dwDataLen=fread(lpData,sizeof(BYTE),1024,hSource);
				Eof=dwDataLen<1024;
				memcpy(lpTempData,lpData,dwDataLen);//     .
				b=CryptEncrypt(hKey,0,Eof,0,lpTempData,&dwDataLen,dwBufLen);
				a=GetLastError();
				b&=(fwrite(lpTempData,sizeof(BYTE),dwDataLen,hDestination)==dwDataLen);
				if(!b)
				{
					free(lpData);
					free(lpTempData);
					CryptDestroyKey(hKey);
					CryptReleaseContext(hCryptProv,0);
					fclose(hSource);
					fclose(hDestination);
					HandleError("Error while crypting file or writing it to disk",GetLastError());

				}
			}while(!Eof);
			fclose(hSource);
			fclose(hDestination);
			free(lpTempData);
			free(lpData);
			CryptDestroyKey(hKey);
			break;
		default: CryptReleaseContext(hCryptProv,0);//  ,        ,  CryptDestroyKey(hKeY);   
			Usage();
		}//end switch
	}//end else from checking of first parameter
	return 0;
	//end else. delete this line
}
